print("Hello " .. UnitName("Player") .. " Kals_MovableMoneyLabel is running. Use '/MML reset' to reset position");


local _relativeTo = "";
local _xPos = "";
local _yPos = "";
local _scale = 1;

local CheckOnLoad = CreateFrame("FRAME", "AddonFrame");
CheckOnLoad:RegisterEvent("ADDON_LOADED");
CheckOnLoad:RegisterEvent("PLAYER_LOGOUT");

function CheckOnStart(self, event, ...)
	if(event == "ADDON_LOADED" and ... == "Kals_MovableMoneyLabel") then
		if(_relativeToGlobal == nil) then
			_relativeTo = "CENTER";
		else
			_relativeTo = _relativeToGlobal;
		end

		if(_xPosGlobal == nil) then
			_xPos = 0;
		else
			_xPos = _xPosGlobal;
		end

		if(_yPosGlobal == nil) then
			_yPos = 0;
		else
			_yPos = _yPosGlobal;
		end

		if(_scaleGlobal == nil) then
			_scale = 1;
		else
			_scale = _scaleGlobal;
		end

		MyMoneyFrame();
		BuildUI();
	end

	if( event == "PLAYER_LOGOUT") then
		_relativeToGlobal = _relativeTo;
		_xPosGlobal = _xPos;
		_yPosGlobal = _yPos;
		_scaleGlobal = _scale;
	end
end
CheckOnLoad:SetScript("OnEvent", CheckOnStart);


local CheckMoney = CreateFrame("FRAME", "MoneyFrame");
CheckMoney:RegisterEvent("PLAYER_MONEY");
CheckMoney:RegisterEvent("MERCHANT_SHOW");
CheckMoney:RegisterEvent("PLAYER_CONTROL_GAINED");
CheckMoney:RegisterEvent("PLAYER_ENTERING_WORLD");

 
 function MyMoneyFrame(self, event, ...)
	--print(event);
	if(GoldText ~= nil)then
		GoldText:SetText(GetCoinTextureString(GetMoney()));
	end
end
CheckMoney:SetScript("OnEvent", MyMoneyFrame);


local MoneyFrame = {};
local GoldText = {};

 function BuildUI()
	--print("_relativeTo on start: " .. _relativeTo);
	--print("x on start: " .. _xPos);
	--print("y on start: " .. _yPos);

	MoneyFrame = CreateFrame("Frame", "MoneyFrame", UIParent)
	MoneyFrame:SetFrameStrata("HIGH");
	MoneyFrame:SetWidth(200);
	MoneyFrame:SetHeight(20);
	MoneyFrame:SetPoint(_relativeTo, UIParent, _relativeTo, _xPos, _yPos);
	MoneyFrame:SetScale(_scale);

	MoneyFrame:SetMovable(true);
	MoneyFrame:EnableMouse(true);
	MoneyFrame:RegisterForDrag("LeftButton");
	MoneyFrame:SetScript("OnDragStart", MoneyFrame.StartMoving);
    MoneyFrame:SetScript("OnDragStop", 
    	function(self, event, ...)
    		MoneyFrame:StopMovingOrSizing();
			StorePosition();
		end
    	);

	GoldText = MoneyFrame:CreateFontString("GoldText", "OVERLAY", "GameFontNormal");
	GoldText:SetPoint("LEFT", MoneyFrame, "LEFT");

	GoldText:SetText(GetCoinTextureString(GetMoney()));
end

function StorePosition()	
	print("Kals_MovableMoneyLabel - Saving new position");

	--print(MoneyFrame:GetPoint());

	_relativeTo = select(1, MoneyFrame:GetPoint());
	_xPos = select(4, MoneyFrame:GetPoint());
	_yPos = select(5, MoneyFrame:GetPoint());
	--print("_relativeTo:" .. _relativeTo);
	--print("x:" .. _xPos);
	--print("y:" .. _yPos);
end

--CONSOLE
SLASH_MovableMoneyLabel1 = "/MML";

SlashCmdList.MovableMoneyLabel = function(msg)
	msg = string.lower(msg);

	if(msg == "")then
		print("Scale examle: '/mml 1.2' to increase scale by 20%");
		print("use '/mml reset' to reset position and scale");

	elseif(msg == "reset")then
		print("Resetting MovableMoneyLabel");
		MoneyFrame:SetPoint("CENTER", 0, 0);
		MoneyFrame:SetScale(1);

	elseif(tonumber(msg) ~= nil) then
		_scale = msg;
		MoneyFrame:SetScale(msg);
	else
		print("|CFFe60000 ERROR");
		print("|CFFffff00 Wrong input");	
		print("Scale example: '/mml 1.2' to increase scale by 20%");
		print("use /mml reset to reset position and scale");
	end
end 	